# coding=utf_8

import os,sys
import funclib

cfg_init_done = False
cfg_data = {}
cfg_groups = {}
cfg_groups_index = []
cfg_filename = "config.ini"

def init():
	''' Inicializace & nacteni configu. '''
	global cfg_filename,cfg_init_done
	if cfg_init_done:return False
	parse(cfg_filename)
	cfg_init_done = True
	''' Vystup chybovych hlaseni do souboru temp/trace.log '''
	if not get('develmode'):
		fp_stderr = open('trace.log','w+')
		sys.stderr = fp_stderr
		fp_stdout = open('all.log','w+')
		sys.stdout = fp_stdout

def parse(fname):
	def repall(st,li,rep):
		for s in li:st = st.replace(s,rep)
		return st
	fp = open(funclib.Path(fname),"rb")
	data = fp.readlines()
	fp.close()
	group = "-1"
	for line in data:
		line = repall(line,('\n','\r'),'')
		if line == "":continue
		if line[0] == "#":continue
		if line[0] == "[":
			group = line[1:-1]
			cfg_groups[group] = []
			cfg_groups_index.append(group)
			continue
		try:
			line = repall(line,(" = "," =","= "),"=")
			line = line.split("=")
			cfg_groups[group].append(line[0])
			if line[1][0] in ("'",'"'):
				d = line[1][1:-1]
			elif line[1].find(".") != -1:
				d = float(line[1])		
			else:
				d = int(line[1])		
			cfg_data[line[0]] = d
		except:
			print 'CfgParse: error parsing line: %s'%line
	del data

def setval(uid,value):
	cfg_data[uid] = value
	
def get(uid):
	if not cfg_init_done:
		print "cfg: config system is not initialized"
	return cfg_data[uid]
	
def add(uid,group,value):
	cfg_data[uid] = value
	if not group in cfg_groups:
		cfg_groups[group] = []
		cfg_groups_index.append(group)
	if not uid in cfg_groups[group]:
		cfg_groups[group].append(uid)
		
def rem(uid,group):
	if uid in cfg_groups[group]:
		index = cfg_groups[group].index(uid)
		cfg_groups[group][index] = False
		return True
	return False

def remGroup(group):
	cfg_groups[group] = False
	
def save(fname=cfg_filename):
	fp = open(funclib.Path(fname),"wb")
	out = []
	out.append("#GCFGv1\n# BATL Game Configuration")
	for group in cfg_groups_index:
		out.append("\n[%s]"%group)
		if not cfg_groups[group]:continue
		for item in cfg_groups[group]:
			if not item:continue
			d = cfg_data[item]
			if isinstance(d,str) or isinstance(d,unicode):
				out.append("%s = '%s'"%(item,d))
			else:
				out.append("%s = %s"%(item,d))
	out = '\n'.join(out)
	fp.write(out)
	fp.close()


