# coding=utf_8
'''
	Kalaten RPG - http://kalaten.cz
	author: (c) 2011 Josef Vanžura 
	
	Licencováno pod GNU/LGPL.

	Tato knihovna je svobodný software; můžete ji šířit a upravovat
	v souladu s podmínkami GNU Lesser General Public License,
	tak jak ji vydala nadace Free Software Foundation; buď verze 2.1
	této licence, anebo (dle svého uvážení) kterékoli pozdější verze.

	Pro další podrobnosti viz GNU Lesser General Public License.

	Plné znění (anglicky) licence naleznete v souboru license.txt ve složce hry.
'''

import os,random,time

def getHomeDirPath(f=""):
	pth = os.path.normpath(os.path.expanduser('~/%s'%f))
	return pth
	
def makeHomeDirStruct(paths):
	for p in paths:
		try:
			os.mkdir( getHomeDirPath(p) )
		except:
			print "funclib.makeHomeDirStruct: can't create dir '%s'"%p

def term_pbar(v):
	v = int( v * 100 )
	pb = "".ljust(v/5,"|")
	pb = pb.ljust(20,"-")
	print " [%s] %s %%\r"%(pb,v),
	
def weightedChoice(arr):
	if not arr: return []
	count = 0
	for a,p in arr:
		count += p
	rnd = random.randint(1,count)
	index = 0
	result = None
	arrlen = len(arr)
	while rnd > 0 and index < arrlen:
		rnd += -arr[index][1]
		result = arr[index][0]
		index += 1
	if result == None:
		print rnd
	return result

def fsizeToStr(num):
	return int2byte(num,4)
	
def strToFsize(st):
	return byte2int(st)

def int2byte(num,length=1):
	out = ""
	count = 0
	for n in xrange(length):
		pwr = 255**(length-n-1)
		v = (num-count) / pwr
		out += chr(int(v))
		count += int(v)*pwr
	return out
	
def byte2int(string):
	cnt = 0
	num = 0
	length = len(string)
	for character in string:
		v = ord(character)
		pwr = (length - cnt)-1
		num += v * (255**pwr)
		cnt+=1
	return num


def irange(start, finish):
	if start == finish:
		return [start]
	if start < finish:
		return range(start, finish + 1)
	if start > finish:
		return range(start, finish - 1, -1)

def Path(pth):
	''' Normalizuje cestu k souboru '''
	if isinstance(pth,str):
		return os.path.normpath(pth)
	else:
		return os.path.normpath((os.sep).join(pth))

def fileremove(f):
	''' Bezpecne mazani souboru '''
	try:
		os.remove(f)
		return True
	except:
		return False
		
def filesize(f):
	try:
		return os.stat(f).st_size
	except:
		return False

def filemtime(f):
	try:
		return os.stat(f).st_mtime
	except:
		return False


def testLine(l):
	if l == "[":return True
	if l == "{":return True
	if l == "#":return True
	if l == "\n":return True
	return False
	
def lineDelimit(l):
	if l.find("\t") != -1:
		while l.find("\t\t") != -1:
			l = l.replace('\t\t',"\t")
		l = l.split("\t")
	else:
		l = l.split(";")
	return l

def gen_uid(n=3):
	out = ""
	for q in xrange(n):
		out += str(hex(int( random.random()*time.time() )))[2:]
	return out

def randomItem(ilist,excl=-1):
	''' Nahodny prvek z pole: [(prvek,%),..] '''
	# trideni
	if not ilist:return False
	nlist = []
	for n in ilist:
		itm,p = n
		if itm == excl:continue
		perc = round(random.random()*100)
		if p > perc:nlist.append(itm)
	if nlist:
		return random.choice(nlist)
	else:
		return False

def read_version():
	fp = open("version","rb")
	dat = fp.read()
	dat = dat.replace("\n","")
	dat = dat.replace("\r","")
	dat = dat.replace(" ","")
	fp.close()
	return dat
	
def compare_versions(v1,v2):
	return float(v1)-float(v2)
	
	
