# coding=utf_8

import pygame,glo,res,def_units,unit
import os

FONT_FILE = "data/gunplay.ttf"

_gui_offset = 0
_building_buttons = {}

def renderString(text,size=12,color=(255,255,255)):
	font = pygame.font.Font(os.path.normpath(FONT_FILE), size-2)
	return font.render(text,True,color)

def renderTooltip(text):
	font = pygame.font.Font(os.path.normpath(FONT_FILE), 11)
	return font.render(" "+text+" ",True,(255,255,255),(0,0,0))

def colorize_image(img,player):
	plc = res.cache.get("player_colors")
	color = (plc.get_at((0,player*10))).hsla[0]
	w,h = img.get_size()
	for x in xrange(w):
		for y in xrange(h):
			clr = img.get_at((x,y))
			hue,s,l,a = clr.hsla
			if hue == 300:
				hue = color
				clr.hsla = hue,s,l,a
				img.set_at((x,y),clr)
	return img

def check_mouse_move(_p):
	x,y = _p
	x = (x-_gui_offset)
	for k in glo.gui:
		i = glo.gui[k]
		p = i[1]
		s = i[2]
		i[4] = 0
		if not i[5]:continue
		if p[0]<=x<=(p[0]+s[0]) and p[1]<=y<=(p[1]+s[1]):
			i[4] = 1
	return False
	
def check_mouse_click(_p):
	x,y = _p
	x = (x-_gui_offset)
	for k in glo.gui:
		i = glo.gui[k]
		p = i[1]
		s = i[2]
		if not i[5]:continue
		if p[0]<=x<=(p[0]+s[0]) and p[1]<=y<=(p[1]+s[1]):
			i[0](i[3])
			return True
	return False
	

def paint_ingame():
	blit_gui_item("money",(415,0))
	blit_gui_item("map",(520,0))
	
	paint_button("build")
	paint_button("menu")
	
	txt = "$%s"%int(glo.iam.money)
	txt = renderString(txt,12,(255,255,255))
	glo.screen.blit(txt,(170+420,10))
	
	for t in glo.targeting:
		hide_button("target_%s"%t)
	if _building_buttons:
		for u in def_units.build:
			hide_button("build_%s"%u)
	hide_button("mktower")
	
	if glo.selected:
		if glo.iam in glo.selected:
			paint_building()
		else:
			blit_gui_item("title",(5,0))
			u = glo.selected[0]
			if u.transform:
				show_button("mktower")
				paint_button("mktower")
				
			for t in glo.targeting:
				show_button("target_%s"%t)
				paint_button("target_%s"%t)

	_selected = {}
	for u in glo.units:
		if u in glo.selected:
			if u.name not in _selected:
				_selected[u.name] = 0
			_selected[u.name] += 1

	if glo.selected and not glo.iam in glo.selected:
		_strs = []
		for s in _selected:
			c = _selected[s]
			_strs.append("%sx %s"%(c,s))
		_strs = ', '.join(_strs)

		txt = renderString(_strs,11,(0,255,0))
		glo.screen.blit(txt,(185,9))

	paint_tooltips()
	index = 0
	img = res.cache.get("player_colors")
	for p in glo.players:
		glo.screen.blit(img,(10,10+(index*15)),( 0,index*10,10,10 ))
		cl = (250,250,250)
		if glo.player_id == p.uid:
			cl = (0,250,0)
		txt = renderString(p.name,12,cl)
		glo.screen.blit(txt,(25,10+(index*15)))
		index += 1

def paint_building():
	blit_gui_item("large",(0,0))
	ofx = 170+15
	ofy = 10
	x = 0
	y = 0
	for u in def_units.build:
		show_button("build_%s"%u)
		paint_button("build_%s"%u)
		glo.screen.blit(_building_buttons[u],(ofx+x,ofy+y))
		if u[0] == "@":
			num = def_units.abilites[u[1:]]["count"]
			txt = renderString("%sx"%num,14,(255,255,255))
			glo.screen.blit(txt,(ofx+x+1,ofy+y+1))
		x += 50
		if x == 7*50:
			x = 0
			y = 50

def make_building_buttons():
	x = 0
	y = 0
	for u in def_units.build:
		if u[0] == "@":
			de = def_units.abilites[u[1:]]
			srf = res.cache.get("ability_%s"%u[1:])
			txt = renderString("$%s"%de['price'],10,(250,250,250))
			tx = (40-txt.get_width())/2
			srf.blit(txt,((tx,27)))
			_building_buttons[u] = srf

			add_button("build_%s"%u,unit.use_ability,(x+15,y+10),(40,40),u[1:],False,"buildunit",de['name']+" - "+de['desc'])
		else:
			de = def_units.units[u]
			img = unit.mk_unit_image(de['image'],glo.iam.player_id).copy()
			img.blit(res.cache.get("%s_b"%de['image']),(0,de['trans_turret']))
			srf = pygame.transform.smoothscale(img,(40,40))
			txt = renderString("$%s"%de['price'],10,(250,250,250))
			tx = (40-txt.get_width())/2
			srf.blit(txt,((tx,27)))
			_building_buttons[u] = srf
		
			add_button("build_%s"%u,unit.build_unit,(x+15,y+10),(40,40),u,False,"buildunit",de['name']+" - "+de['desc'])
		x += 50
		if x == 7*50:
			x = 0
			y = 50

def blit_gui_item(img,pos):
	of = (_gui_offset,0)
	if isinstance(img,str):
		img = res.cache.get("gui_%s"%img)
	glo.screen.blit(img,(of[0]+pos[0],of[1]+pos[1]))

def add_button(uid,func,pos,size,arg=False,disp=True,img=False,ttip=False):
	if not img:img = uid
	glo.gui[uid] = [ func, (pos[0],pos[1]), size, arg, 0, disp, img, ttip ]

def show_button(uid):
	glo.gui[uid][5] = True

def hide_button(uid):
	glo.gui[uid][5] = False

def paint_button(uid):
	if not glo.gui[uid][5]:return False
	ov = glo.gui[uid][4] and "o" or "n"
	img = glo.gui[uid][6]
	blit_gui_item("%s_%s"%(img,ov),glo.gui[uid][1])
	
def paint_tooltips():
	for i in glo.gui:
		e = glo.gui[i]
		if not e[5]:continue
		if e[7] and e[4]:
			glo.screen.blit(renderTooltip(e[7]),pygame.mouse.get_pos())
			break
	
	
_minimap_data = None
def paint_minimap():
	global _minimap_data
	if not _minimap_data:
		w = glo.map_data['size'][0]
		h = glo.map_data['size'][1]
		_minimap_data = pygame.Surface((w*2,h*2))
		_t = []
		for t in glo.tiles:
			img = pygame.transform.smoothscale(res.cache.get("tile_%s"%t),(2,2))
			_t.append(img)
		for y in xrange(h):
			for x in xrange(w):
				v = glo.map_data['data'][y][x]
				_minimap_data.blit(_t[v],(x*2,y*2))
	img = _minimap_data.copy()
	for u in glo.units:
		if u.dead:continue
		x,y = u.pos
		tx = int(x/25)
		ty = int(y/25)
		img.blit(res.cache.get("player_colors"),(tx,ty),(0,10*(u.player_id),2,2))
	pygame.draw.rect(img,(255,255,255),(glo.view_pos[0]/25,glo.view_pos[1]/25,16*2,12*2),1)
	img = pygame.transform.smoothscale(img,(100,100))
	glo.screen.blit(img,(170+525,5))

