
import glo,netw,unit,cfg,time

mpl = None

def start_server():
	global mpl
	mpl = MPLServer()
	mpl.start()

def start_client(ip=False):
	global mpl
	mpl = MPLClient()
	mpl.start(ip)
	
def start_searching():
	global mpl
	mpl = MPLBCListener()
	mpl.start()

def netSend(pkg):
	print "SEND",pkg
	mpl.netw.send(pkg)
	
def sendUnitsCorr():
	if not glo.units:return False
	if glo.tick%12 != 0:return False
	uinfo = []
	for n in xrange(10):
		index = glo.units_corr+n
		if index >= len(glo.units):
			break
		else:
			u = glo.units[index]
			uinfo.append(( u.uid,round(u.hp,2),u.dead,u.rank,u._targeting ))
	glo.units_corr += 10
	if glo.units_corr > len(glo.units):
		glo.units_corr = 0
	netSend(("CORR",uinfo))

	
class MPLBase:
	def _calls(self,d):
		if self.server:
			addr,data = d
		else:
			data = d
		cmd = data[0]
		print "RECV",data
		if glo.game_started:
			if cmd == "GOTO":
				for u,g in data[1]:
					unit.get_unit(u).goto(g)
				if self.server:
					self.netw.send(data,addr)
			if cmd == "TARGET":
				for u,t in data[1]:
					unit.get_unit(u).targeting(t)
				if self.server:
					self.netw.send(data,addr)
			if cmd == "EFFECT":
				glo.add_effect(data[1],data[2])
				if self.server:
					self.netw.send(data,addr)
			if cmd == "ABILITY":
				unit._use_ability(data[1],data[2])
				if self.server:
					self.netw.send(data,addr)
			if cmd == "AUNIT":
				if self.server:
					u = unit.add_unit_do(data[1],data[2],data[3])
					_data = ("AUNIT",data[1],data[2],data[3],u.uid)
					self.netw.send(_data)
				else:
					unit.add_unit_do(data[1],data[2],data[3],data[4])

			if cmd == "DUNIT":
				unit.delete_unit_do(data[1])
				if self.server:
					self.netw.send(data)
					
			if cmd == "CORR":
				for d in data[1]:
					uID,uHP,uD,uR,uT = d
					uHP = round(uHP,2)
					u = unit.get_unit(uID)
					if u:
						u.hp = uHP
						u.dead = uD
						u.rank = uR
						u._targeting = uT
					else:
						glo.messages.append("CORR: Missing unit: %s"%uID)
		if cmd == "GCOR":
			sendUnitsCorr()
		if cmd == "LOBB":
			glo.lobby_clients = data[1]
			glo.map_file = data[2]
			glo.map_money = data[3]
			index = 0
			for c,a in glo.lobby_clients:
				if a != -1:
					if "%s:%s"%a == self.addr:
						glo.player_id = index
						break
				index += 1
		if cmd == "TOUCH":# client > server
			if (data[1],addr) not in glo.lobby_clients:
				glo.lobby_clients.append((data[1],addr))
		if cmd == "START":# server > client
			glo.game_started = True
			netSend(("GO",))
			
		if cmd == "GO":# client > server
			glo.clients.append(addr)
			if len(glo.clients) == (len(glo.lobby_clients)-1):
				glo.game_started = True
			

class MPLServer(MPLBase):
	def __init__(self):
		self.netw = None
		self.server = True
		self.addr = -1
		self._t = 0
	
	def tick(self):
		if glo.game_started:
			sendUnitsCorr()
		else:
			# lobby
			if self._t%10 == 0:
				_cls = []
				for c,a in glo.lobby_clients:
					if a == -1:
						_cls.append((c,-1))
					elif a in self.netw.addrs:
						_cls.append((c,a))
				glo.lobby_clients = _cls
				self.netw.send(("LOBB",_cls,glo.map_file,glo.map_money))
		self._t+=1

	def start(self):
		self.netw = netw.Server("",cfg.get("port"),self.calls,cfg.get("broadcast"))
		glo.lobby_clients.append((cfg.get("player_name"),-1))

	def calls(self,t,data):
		if t == "data":
			self._calls(data)
		if t == "nobind":
			print "Cannot start server: %s"%data
			glo.messages.append(data)
		if t == "error":
			glo.messages.append(data)
		
	def get_clients(self):
		_arr = []
		for c in self.netw.clients:
			_arr.append("%s:%s"%c[1])
		return _arr


class MPLClient(MPLBase):
	def __init__(self):
		self.netw = None
		self.server = False
		self.addr = ""
		self._t = 0
		
	def tick(self):
		if not self.netw.connection:return False
		if glo.game_started:
			pass
		else:
			# lobby
			if self._t%20 == 0:
				self.netw.send(("TOUCH",cfg.get("player_name")))
			pass
		self._t+=1
		
	def start(self,ip=False):
		if not ip:ip = cfg.get("server_ip")
		self.netw = netw.Client(ip,cfg.get("port"),self.calls)
		
	def calls(self,t,data):
		if t == "data":
			try:
				self._calls(data)
			except Exception,e:
				print "EXC: ",e
		if t == "addr":
			self.addr = data
		if t == "error":
			glo.messages.append(data)

class MPLBCListener:
	def __init__(self):
		self.netw = None
		self.server = False
		self.addr = ""
		self._t = 0
		
	def tick(self):
		pass
		
	def calls(self,data):
		uid = "%s"%data[1][0]
		glo.lobby_games[uid] = data
		
	def start(self):
		self.netw = netw.BroadcastListener('',cfg.get("port"),self.calls)
