
import pygame,math,random
import res,grid,glo,mpl,particles,gui
import def_units


_unit_imgs = {}
def mk_unit_image(img,pl):
	uid = "%s_%s"%(img,pl)
	if not uid in _unit_imgs:
		_unit_imgs[uid] = gui.colorize_image( res.cache.get("%s_a"%img).copy(), pl)	
	return _unit_imgs[uid]

def use_ability(ab):
	ability = def_units.abilites[ab]
	if ability["count"]:
		if glo.iam.money >= ability['price']:
			glo.iam.money += -ability['price']
			ability["count"] += -1
			_use_ability(ab,glo.iam.player_id)
			mpl.netSend(("ABILITY",ab,glo.iam.player_id))

def _use_ability(uid,player):
	def_units.abilites[uid]["func"](player)
	

def build_unit(v=0):
	de = def_units.units[v]
	if glo.iam.money >= de['price']:
		glo.iam.money += -de['price']
		x,y = glo.iam.pos
		dx = ((glo.unit_count-100)%10)*5
		dy = (((glo.unit_count-100)%100)/10)*5
		add_unit(v,(x+dx,y+dy),glo.iam.player_id)
		
def add_unit(model,pos,player):
	if mpl.mpl.server:
		u = add_unit_do(model,pos,player)
		mpl.netSend(("AUNIT",model,pos,player,u.uid))
	else:
		mpl.netSend(("AUNIT",model,pos,player))

def add_unit_do(model,pos,player,uid=False):
	u = Unit(model,pos,player)
	glo.units.append( u )
	if uid:u.uid = uid
	return u

def delete_unit(uid):
	mpl.netSend(("DUNIT",uid))
	if mpl.mpl.server:delete_unit_do(uid)
	
def delete_unit_do(uid):
	get_unit(uid).delete()

def mktower(v=0):
	u = glo.selected[0]
	add_unit(u.transform,u.pos,u.player_id)
	delete_unit(u.uid)
	glo.selected = []

def get_unit(uid):
	for u in glo.units:
		if u.uid == uid:return u
	return False

def explosion(pos,v=1):
	if v == 1:l,s,p = 10,2.1,10
	if v == 2:l,s,p = 14,5.1,15
	if v == 3:l,s,p = 16,8.1,20
	particles.Emitter(glo.screen,{
				"image": ("particle6","particle1","particle3","particle5"),
				"life": l,
				"pos": glo.relcoords(pos),
				"pos_range": ((-5,5),(-5,5)),
				"vec_direction": (-1,1),
				"vec_speed": (0.1,s),
				"ppt": p,
				"func": particles.PARTICLE_MOVE_LINEAR
	}).emitt()
	if v > 1:
		glo.add_effect("shake",v*2)
	if v == 3:
		glo.add_crater(pos)
		glo.add_effect("bloom",2)

class Rocket:
	def __init__(self,unit,trans=0,angle=0):
		self.unit = unit
		self.trans = trans
		self.destroyed = False
		
		self.damage = self.unit.damage
		self.speed = self.unit.rocket_speed
		self.range = self.unit.range
		self.way = 0
		
		ang = self.unit.rotate_turret+self.unit.rotate_body+angle
		self.angle = (ang/180.0)*math.pi
		tx,ty = self.unit.get_rot_pos(self.unit.trans_turret)
		txx,tyy = self.unit.get_rot_pos(self.trans,( self.angle+(math.pi/2) ))
		x,y = self.unit.pos
		self.pos = (x+tx+txx,y+ty+tyy)
		self.ipos = self.pos
		img = self.unit.rocket_image.copy()
		self.image = pygame.transform.rotate(img,ang)
		self.size = (
			(self.image.get_width()/2),
			(self.image.get_height()/2)
		)
		glo.rockets.append(self)
		self.x = math.sin(self.angle)*self.speed
		self.y = math.cos(self.angle)*self.speed
		
		eang = ((ang-math.pi)/180.0)
		self.emitt = particles.Emitter(glo.screen,{
			"image": ("particle3","particle2","particle2","particle5"),
			"life": 9,
			"pos": glo.relcoords(self.pos),
			"pos_range": ((0,0),(0,0)),
			"vec_direction": (-1,1),
			"vec_speed": (1.0,1.1),
			"ppt": 1,
			"func": particles.PARTICLE_MOVE_LINEAR
		})
	
	def explode(self,unit):
		self.unit.set_rank(1)
		unit.harm(self.unit)
		self.destroy()
		
	def destroy(self):
		explosion(self.pos,1)
		self.destroyed = True
		try:self.emitt.delete()
		except:pass
		glo.rockets.remove(self)
		
	def update(self):
		if self.destroyed:return False
		# test kolize
		for u in glo.units:
			if u.dead:continue
			if u.is_enemy(self.unit):
				distance = grid.get_distance(self.pos,u.pos)
				if distance <= u.size:
					self.explode(u)
					return
		self.pos = (self.pos[0]+self.x,self.pos[1]+self.y)
		self.ipos = glo.relcoords((
			self.pos[0]-self.size[0],
			self.pos[1]-self.size[1],
		))
		self.range += -self.speed
		self.way += 1
		if self.range <= 1:
			self.destroy()
		if self.way >= 5:
			ex = (self.pos[0]-self.size[0])-(self.x*2)
			ey = (self.pos[1]-self.size[1])-(self.y*2)
			try:self.emitt.pos = glo.relcoords((ex,ey))
			except:pass

	def blit(self,srf,ovrl):
		if self.destroyed:return False
		try:self.emitt.emitt()
		except:pass
		if grid.pos_in_view(self.pos,glo.view_pos,glo.resolution):
			srf.blit(self.image,self.ipos)

class Unit:
	def __init__(self,model,pos,player):
		uid = glo.unit_count+(player*10000)
		glo.unit_count += 1
		if model in def_units.units:
			data = def_units.units[model]
		else:
			raise IndexError,"Unit model '%s' is not defined."%model
		self.uid = uid
		self.base = False
		self.model = model
		self.name = data['name']
		self._class = data['class']
		self._targeting = "none"
		self.player_id = player
		self.player = None
		for p in glo.players:
			if p.uid == player:
				self.player = p
				break
		self.pos = pos
		self.hp = float(data['hp'])
		self.repair = data['repair']
		self.hp_max = float(data['hp'])
		self.speed = data['speed']
		self.fire_rate = data['fire_rate']
		self.range = data['range']
		self.damage = data['damage']
		self.damage_type = data['damage_type']
		self.defense = data['defense']
		self.money_grab = data['money_grab']
		
		if "transform" in data:
			self.transform = data["transform"]
		else:
			self.transform = False
		
		if self.damage_type == 'rocket':
			self.rocket_speed = data['rocket_speed']
			self.rocket_def = data['rocket_def']
			self.rocket_image = res.cache.get(data['rocket_image'])
			self.rocket_random = data['rocket_random']
		
		self.tick = 0
		self.dead = False
		self.render_state = 0
		self.rank = 0
		self._deadticks = 360
		
		self.cache = {}
		self.healing = False
		self.harvesting = False
		self.fire_cooldown = 0
		self._emitt = 0
		self._fire = 0
		self._hit = 0
		self._hitnum = 3
		self._goto = self.pos
		self._lastpos = [self.pos,self.pos,self.pos,self.pos,self.pos]
		self._target = None
		self.explo = data['explo']
		self.img = data['image']
		self.image_body = mk_unit_image(self.img,self.player_id)
		self.image_size = self.image_body.get_size()
		self.size = self.image_size[0]/2
		self.image_turret = res.cache.get("%s_b"%self.img)
		self.image_fire = [
			res.cache.get("%s_f3"%self.img),
			res.cache.get("%s_f2"%self.img),
			res.cache.get("%s_f1"%self.img),
		]
		self.image_explo = res.cache.get("%s_e"%self.img)
		self.srf = pygame.Surface(self.image_size).convert_alpha()
		selected_img = res.cache.get("selected")
		self.selimg = pygame.transform.smoothscale(selected_img.copy(),self.image_size)
		
		self.rotate_body = 0
		self.rotate_turret = 0
		self.trans_turret = data['trans_turret']
		self.make_img()
		
	def delete(self):
		glo.units.remove(self)
		
	def harm(self,byunit,damage=0):
		if damage:
			dmg = damage
		else:
			dmg = byunit.damage*(byunit.get_rank()+1)
			dmg = dmg-self.defense
		if dmg<=0:return False
		self.hp += -dmg
		self._hit = self._hitnum
	
	def set_rank(self,v):
		self.rank += v
	
	def get_rank(self):
		r = self.rank/20
		if r>7:r=7
		return r
		
	def scan_enemy(self):
		#if self._target and self._target.dead:self._target = False
		
		#if self._target:
		#	distance = grid.get_distance(self.pos,self._target.pos)
		#	if distance > self.range:self._target = False
		#	else:return False
		
		_units = []
		for u in glo.units:
			if u.dead:continue
			if self.is_enemy(u):
				distance = grid.get_distance(self.pos,u.pos)
				if distance <= self.range:
					_units.append( u )
		_d = 100000
		_u = None
		_dp = _d
		_up = None
		for u in _units:
			distance = grid.get_distance(self.pos,u.pos)
			if self._targeting in u._class or (self._targeting == "ranked" and u.get_rank()):
				if distance <= _dp:
					_up = u
					_dp = distance
			if distance <= _d:
				_u = u
				_d = distance
		if _up:_u = _up
		self._target = _u
		
	def is_enemy(self,unit):
		if self.player.group != unit.player.group:return True
		return False
		
	def goto(self,pos,nonet=False):
		if self.dead:return
		if self.speed == 0:return False
		self._goto = (int(pos[0]),int(pos[1]))
		
	def targeting(self,t,nonet=False):
		if self.dead:return
		self._targeting = t
		
	def fire(self):
		if self.dead:return
		if self.fire_cooldown == 0:
			self.fire_cooldown = self.fire_rate
			ax,ay = self.pos
			tx,ty = self._target.pos
			distance = math.hypot(ax-tx,ay-ty)
			if distance <= self.range and distance > self.size:
				if self.damage_type == "rocket":
					self._fire = 3
					index = 0
					for r in self.rocket_def:
						Rocket(self,r,self.rocket_random[index])
						index += 1
				if self.damage_type == "slug":
					self._fire = 3
					self._target.harm(self)
					self.set_rank(1)
		
	def target(self,unit):
		self._target = unit
		
	def get_rot_pos(self,trans,ang=None):
		if ang == None:
			ang = (self.rotate_body/180.0)*math.pi
		x = math.sin(ang)*trans
		y = math.cos(ang)*trans
		return x,y
		
	def make_rotated(self,img_orig,rot,trans=0,noaa=0):
		img = img_orig.copy()
		img_size = img_orig.get_size()
		if rot%360 != 0:
			if noaa:
				img = pygame.transform.rotate(img,rot)
			else:
				img = pygame.transform.scale2x(img)
				img = pygame.transform.rotate(img,rot)
				img = pygame.transform.smoothscale(img,(img.get_width()/2,img.get_height()/2))
		x = (img_size[0]-img.get_width())/2.0
		y = (img_size[1]-img.get_height())/2.0
		if trans:
			_x,_y = self.get_rot_pos(trans)
			x += _x
			y += _y
		self.srf.blit( img,(x,y) )
	
	def make_img(self):
		render_state = "%s.%s.%s.%s"%(self.rotate_body,self.rotate_turret,self._fire,self.dead)
		if render_state == self.render_state:return False
		self.render_state = render_state
		self.srf.fill((0,0,0,0))
		if self.dead:
			self.make_rotated(self.image_explo,self.rotate_body)
			return False
		
		trot = self.rotate_body+self.rotate_turret
		self.make_rotated(self.image_body,self.rotate_body)
		self.make_rotated(self.image_turret,trot,self.trans_turret)
		if self._fire:
			self.make_rotated(self.image_fire[self._fire-1],trot,self.trans_turret,True)
	
	def kill(self):
		self.hp = 0
		if self.dead:return False
		self.dead = True
		#self._target = False
		self._fire = 0
		#self._goto = (0,0)
		if not self._emitt:self._emitt = 10
		self.emitt = particles.Emitter(glo.screen,{
			"image": ("particle1","particle2","particle3","particle4"),
			"life": 10,
			"pos": glo.relcoords(self.pos),
			"pos_range": ((-self.size,self.size),(-self.size,self.size)),
			"vec_direction": (-1,1),
			"vec_speed": (1.0,3.0),
			"ppt": 3,
			"func": particles.PARTICLE_MOVE_LINEAR
		})
		explosion(self.pos,self.explo)
	
	def update(self):
		if self._emitt:
			self._emitt += -1
			try:self.emitt.emitt()
			except:pass
			
		if self.hp <= 0:
			self.kill()
			return False

		if self._fire:
			self._fire += -1
		if self.fire_cooldown:
			self.fire_cooldown += -1
			
		self.tick += 1
		self.scan_enemy()
		
		x,y = self.pos
		x = int(x/50)
		y = int(y/50)
		self.harvesting = False
		if glo.map_data['data'][y][x] == 3 and self.money_grab:
			if (x,y) not in self.player.harvesting_from:
				self.harvesting = True
				self.player.money += self.money_grab
				self.player.harvesting_from.append((x,y))
		self.healing = False
		if glo.map_data['data'][y][x] == 4 and self.hp < self.hp_max:
			self.hp += 0.1
			self.healing = True
		if glo.map_data['data'][y][x] == 5:
			if self._hit == 0:
				self._hit = self._hitnum
			self.hp += -2
		if glo.map_data['data'][y][x] == 6:
			self.hp = -1
		
		#self.repair = (self.get_rank()/30.0)
		if self.repair:
			self.hp += self.repair
			if self.hp > self.hp_max:
				self.hp = self.hp_max
		
		# movement
		tx,ty = self._goto
		ax,ay = self.pos
		ddx = abs(int(tx-ax))
		ddy = abs(int(ty-ay))
		if ddx <= self.speed and ddy <= self.speed:
			self._goto = self.pos
		else:
			self.pos = self.mod_move()
		
		if self._target and self._target.dead and self._fire == 0:
			self._target = False
		
		if self._target:
			at = grid.get_direction(self.pos,self._target.pos)
			ang = ((at/math.pi)*180)
			self.rotate_turret = int((ang-self.rotate_body)/2)*2
			self.fire()
		else:
			self.rotate_turret = 0
	
	def mod_move(self):
		direction = grid.get_direction(self.pos,self._goto)
		rotate = direction
		x,y = self.pos
		dx = math.sin(direction)*self.speed
		dy = math.cos(direction)*self.speed
		mat = (
			(1,1),
			(0,1),
			(1,0),
		)
		for m in mat:
			q = self.move_test(x,y,dx,dy,m)
			if q:
				x,y = q
				break
		self.rotate_body = int((rotate/math.pi)*180)
		return (x,y)
		
	def move_test(self,x,y,dx,dy,m):
		qx,qy = m
		_x = x + dx*qx
		_y = y + dy*qy
		nx = int(_x/50)
		ny = int(_y/50)
		if _x > glo.map_data['size'][0]*50:return False
		if _y > glo.map_data['size'][1]*50:return False
		if glo.map_data['data'][ny][nx] == 1:
			return False
		return (_x,_y)

		
	def blit(self,srf,ovrl):
		offdraw = True
		if not grid.pos_in_view(self.pos,glo.view_pos,glo.resolution):offdraw=False
		w,h = self.image_size
		pos = (int(round(self.pos[0]-(w/2))),int(round(self.pos[1]-(h/2))))
		cpos = (int(self.pos[0]),int(self.pos[1]))

		if not self.dead:
			q = (self.hp/float(self.hp_max))
			bpos = (
				pos[0]+((self.image_size[0]-25)/2),
				pos[1]+((self.image_size[1]-2)),
			)
			if q<0:q=0
			hp = int(q*25)
			# hpecka
			if offdraw:
				pygame.draw.line(srf,(40,40,40),glo.relcoords(bpos),glo.relcoords((bpos[0]+25,bpos[1])),2)
				cl = (int(250*math.cos(q)), int( 250*math.sin(q) ), 50)
				pygame.draw.line(srf,cl,glo.relcoords(bpos),glo.relcoords((bpos[0]+hp,bpos[1])),2)
			
			# rank
			if self.rank:
				x = 0
				for n in xrange(self.get_rank()):
					ovrl.blit(res.cache.get("rank"),glo.relcoords((bpos[0]+x,bpos[1]+3)))
					x += 4
			
			# vybrana jednotka
			if self in glo.selected:
				if offdraw:
					index = glo.targeting.index(self._targeting)
					img = res.cache.get("symbols")
					_x = (index%4)*16
					_y = (index/4)*15
					# symbol zamereni
					ovrl.blit(img,glo.relcoords((bpos[0]+27,bpos[1]-4)),(_x,_y,16,15))
					# kruh pod jednotkou
					srf.blit(self.selimg,glo.relcoords(pos),None,pygame.BLEND_RGB_ADD)
					
					# range kruh
					if self.tick%100 > 87:
						rq = ((self.tick%100)/100.0)
						q = math.sin( rq * math.pi )
						r = int(self.range*rq)
						pygame.draw.circle(ovrl,(50*q,50*q,160*q),glo.relcoords(cpos),r,1)
				
				# cara cesty
				if self._goto != self.pos:
					pygame.draw.line(ovrl,(10,50,10),glo.relcoords(cpos),glo.relcoords(self._goto),1)
				# cara zamereni
				if self._target:
					pygame.draw.line(ovrl,(75,12,12),glo.relcoords(cpos),glo.relcoords(self._target.pos),1)
			
			if offdraw:
				iconp = (self.pos[0]-8,self.pos[1]-8)
				if self._hit:
					hitp = (self.pos[0]-15,self.pos[1]-15)
					self._hit += -1
					ovrl.blit(res.cache.get("hit%s"%(self._hit)),glo.relcoords(hitp))
				if self.harvesting:
					ovrl.blit(res.cache.get("harvest%s"%(self.tick%6)),glo.relcoords(iconp))
				if self.healing:
					ovrl.blit(res.cache.get("repair%s"%(self.tick%10)),glo.relcoords(iconp))
		if offdraw:
			srf.blit(self.srf,glo.relcoords(pos))
		#srf.blit(gui.renderString("%s"%self.uid,12,(255,255,0)),glo.relcoords(self.pos))
	
